var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/server.ts
var import_devkit = require("@dynatrace/devkit");
var import_net = require("net");
var readline = __toESM(require("readline"));
var import_stream = require("stream");
var import_v82 = require("v8");

// src/run.ts
var import_types = require("util/types");
var import_path = require("path");
var vm2 = __toESM(require("vm"));

// src/context.ts
var import_buffer = require("buffer");
var import_chalk = require("chalk");
var import_crypto = require("crypto");
var import_os = require("os");
var import_web = require("stream/web");
var import_undici2 = require("undici");
var import_urlpattern_polyfill = require("urlpattern-polyfill");
var import_perf_hooks = require("perf_hooks");
var import_util = require("util");
var import_v8 = require("v8");
var vm = __toESM(require("vm"));

// src/polyfills/domexception.ts
var DOM_EXCEPTIONS = /* @__PURE__ */ ((DOM_EXCEPTIONS2) => {
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["IndexSizeError"] = 1] = "IndexSizeError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["DOMStringSizeError"] = 2] = "DOMStringSizeError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["HierarchyRequestError"] = 3] = "HierarchyRequestError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["WrongDocumentError"] = 4] = "WrongDocumentError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["InvalidCharacterError"] = 5] = "InvalidCharacterError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["NoDataAllowedError"] = 6] = "NoDataAllowedError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["NoModificationAllowedError"] = 7] = "NoModificationAllowedError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["NotFoundError"] = 8] = "NotFoundError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["NotSupportedError"] = 9] = "NotSupportedError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["InUseAttributeError"] = 10] = "InUseAttributeError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["InvalidStateError"] = 11] = "InvalidStateError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["SyntaxError"] = 12] = "SyntaxError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["InvalidModificationError"] = 13] = "InvalidModificationError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["NamespaceError"] = 14] = "NamespaceError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["InvalidAccessError"] = 15] = "InvalidAccessError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["ValidationError"] = 16] = "ValidationError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["TypeMismatchError"] = 17] = "TypeMismatchError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["SecurityError"] = 18] = "SecurityError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["NetworkError"] = 19] = "NetworkError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["AbortError"] = 20] = "AbortError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["URLMismatchError"] = 21] = "URLMismatchError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["QuotaExceededError"] = 22] = "QuotaExceededError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["TimeoutError"] = 23] = "TimeoutError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["InvalidNodeTypeError"] = 24] = "InvalidNodeTypeError";
  DOM_EXCEPTIONS2[DOM_EXCEPTIONS2["DataCloneError"] = 25] = "DataCloneError";
  return DOM_EXCEPTIONS2;
})(DOM_EXCEPTIONS || {});
var DOMException = class extends Error {
  /** */
  constructor(message, name = "Error") {
    super(message);
    this.name = name;
  }
  /** Returns a short that contains one of the error code constants, or 0 if none match */
  get code() {
    return DOM_EXCEPTIONS[this.name];
  }
};

// src/polyfills/atob.ts
var BASE_64_DIGITS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
function atob_default(input) {
  input = `${input}`.replace(/[\t\n\f\r ]+/g, "");
  for (let n = 0; n < input.length; n++) {
    if (!BASE_64_DIGITS.includes(input[n])) {
      throw new DOMException("Invalid character", "InvalidCharacterError");
    }
  }
  return Buffer.from(input, "base64").toString("latin1");
}

// src/polyfills/btoa.ts
function btoa_default(input) {
  input = `${input}`;
  for (let n = 0; n < input.length; n++) {
    if (input[n].charCodeAt(0) > 255) {
      throw new DOMException("Invalid character", "InvalidCharacterError");
    }
  }
  return Buffer.from(input, "latin1").toString("base64");
}

// src/polyfills/fetch.ts
var import_undici = require("undici");
var FORBIDDEN_HEADERS = ["dt-dev-context", "dt-app-context", "dt-dev-app-id"];
function fetch_default(config) {
  return (requestInfo, init = {}) => {
    const headers = new import_undici.Headers(init.headers ?? {});
    const token = config == null ? void 0 : config.token;
    const appId = config == null ? void 0 : config.appId;
    if (token && typeof requestInfo === "string") {
      if (requestInfo.startsWith("/")) {
        headers.set("authorization", `Bearer ${token}`);
        const headerKeys = [...headers.keys()].map((key) => key.toLowerCase());
        FORBIDDEN_HEADERS.forEach((forbidden_header) => {
          if (headerKeys.includes(forbidden_header)) {
            throw new Error(
              `Forbidden request: Header '${forbidden_header}' not allowed in request`
            );
          }
        });
        headers.set("Dt-App-Context", "local-dev-mode");
        headers.set("Dt-Dev-App-Id", appId || "");
        headers.set("Dt-Dev-Context", appId || "");
        const url = new URL(config.devProxyUrl);
        return (0, import_undici.fetch)(`${url.origin}${requestInfo}`, { ...init, headers });
      }
    }
    return (0, import_undici.fetch)(requestInfo, init);
  };
}

// src/polyfills/events.ts
var ErrorEvent = class extends Event {
  colno;
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  error;
  filename;
  lineno;
  message;
  /** */
  constructor(type, eventInitDict = {}) {
    const {
      colno = 0,
      error = null,
      filename = "",
      lineno = 0,
      message = "",
      ...eventInit
    } = eventInitDict;
    super(type, eventInit);
    this.colno = colno;
    this.error = error;
    this.filename = filename;
    this.lineno = lineno;
    this.message = message;
  }
};
var PromiseRejectionEvent = class extends Event {
  promise;
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  reason;
  /** PromiseRejectionEvent constructor */
  constructor(type, eventInitDict = {}) {
    const { promise, reason, ...eventInit } = eventInitDict;
    super(type, eventInit);
    this.promise = promise;
    this.reason = reason;
  }
};
var CustomEvent = class extends Event {
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  details;
  /** */
  constructor(type, options = {}) {
    const { details = null, ...eventInit } = options;
    super(type, eventInit);
    this.details = details;
  }
};
var ProgressEvent = class extends Event {
  lengthComputable;
  loaded;
  total;
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  target;
  /** */
  constructor(type, init = {}) {
    const {
      lengthComputable = false,
      loaded = 0,
      total = 0,
      ...eventInit
    } = init;
    super(type, eventInit);
    this.lengthComputable = lengthComputable;
    this.loaded = loaded;
    this.total = total;
  }
};

// src/polyfills/location.ts
var Location = class {
  hash;
  host;
  hostname;
  href;
  origin;
  pathname;
  port;
  protocol;
  search;
  /** */
  constructor(href) {
    const url = new URL(href);
    url.username = "";
    url.password = "";
    Object.defineProperties(this, {
      hash: {
        get() {
          return url.hash;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.hash".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      host: {
        get() {
          return url.host;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.host".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      hostname: {
        get() {
          return url.hostname;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.hostname".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      href: {
        get() {
          return url.href;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.href".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      origin: {
        get() {
          return url.origin;
        },
        enumerable: true
      },
      pathname: {
        get() {
          return url.pathname;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.pathname".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      port: {
        get() {
          return url.port;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.port".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      protocol: {
        get() {
          return url.protocol;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.protocol".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      search: {
        get() {
          return url.search;
        },
        set() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot set "location.search".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      ancestorOrigins: {
        get() {
          return {
            length: 0,
            item: () => null,
            contains: () => false
          };
        },
        enumerable: true
      },
      assign: {
        value: function assign() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot call "location.assign()".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      reload: {
        value: function reload() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot call "location.reload()".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      replace: {
        value: function replace() {
          throw new DOMException(
            // eslint-disable-next-line quotes
            `Cannot call "location.replace()".`,
            "NotSupportedError"
          );
        },
        enumerable: true
      },
      toString: {
        value: function toString() {
          return url.href;
        },
        enumerable: true
      }
    });
  }
};

// src/polyfills/navigator.ts
var Navigator = class {
  /** */
  constructor() {
    throw new TypeError("Illegal constructor");
  }
};

// src/polyfills/window.ts
var Window = class extends EventTarget {
  /** The Window.self read-only property returns the window itself */
  get self() {
    return this;
  }
};

// src/context.ts
function createContext2(cwd, urlPathname, config) {
  const environmentUrl = (config == null ? void 0 : config.environmentUrl) ?? "http://127.0.0.1";
  const globals = {
    environmentUrl: readOnly(environmentUrl)
  };
  if (config) {
    if (Object.prototype.hasOwnProperty.call(config, "appId")) {
      globals.appId = readOnly(config.appId);
    }
    if (Object.prototype.hasOwnProperty.call(config, "appName")) {
      globals.appName = readOnly(config.appName);
    }
    if (Object.prototype.hasOwnProperty.call(config, "tenantId")) {
      globals.tenantId = readOnly(config.tenantId);
    }
  }
  const href = new URL(environmentUrl);
  href.pathname = urlPathname;
  const location = new Location(href.toString());
  const navigator = Object.create(Navigator);
  Object.defineProperty(navigator, "hardwareConcurrency", {
    get() {
      return (0, import_os.cpus)().length;
    },
    configurable: true,
    enumerable: true
  });
  const globalProperties = Object.defineProperties(new Window(), {
    ...globals,
    AbortController: nonEnumerable(AbortController),
    AbortSignal: nonEnumerable(AbortSignal),
    Blob: nonEnumerable(import_buffer.Blob),
    ByteLengthQueuingStrategy: nonEnumerable(import_web.ByteLengthQueuingStrategy),
    // TODO: This API will become available in Node.js after the version bump to v18 (ADES-2336)
    CompressionStream: nonEnumerable(void 0),
    CountQueuingStrategy: nonEnumerable(import_web.CountQueuingStrategy),
    CryptoKey: nonEnumerable(import_crypto.webcrypto.CryptoKey),
    CustomEvent: nonEnumerable(CustomEvent),
    // TODO: This API will become available in Node.js after the version bump to v18 (ADES-2336)
    DecompressionStream: nonEnumerable(void 0),
    DOMException: nonEnumerable(DOMException),
    ErrorEvent: nonEnumerable(ErrorEvent),
    Event: nonEnumerable(Event),
    EventTarget: nonEnumerable(EventTarget),
    File: nonEnumerable(import_undici2.File),
    FileReader: nonEnumerable(import_undici2.FileReader),
    FormData: nonEnumerable(import_undici2.FormData),
    Headers: nonEnumerable(import_undici2.Headers),
    Performance: nonEnumerable(import_perf_hooks.performance.constructor),
    PerformanceEntry: nonEnumerable(import_perf_hooks.PerformanceEntry),
    PerformanceMark: nonEnumerable(import_perf_hooks.PerformanceMark),
    PerformanceMeasure: nonEnumerable(import_perf_hooks.PerformanceMeasure),
    PromiseRejectionEvent: nonEnumerable(PromiseRejectionEvent),
    Location: {
      value: Location,
      configurable: true,
      writable: true
    },
    location: {
      get() {
        return location;
      },
      set() {
        throw new DOMException(`Cannot set "location".`, "NotSupportedError");
      },
      enumerable: true
    },
    ProgressEvent: nonEnumerable(ProgressEvent),
    ReadableStream: nonEnumerable(import_web.ReadableStream),
    ReadableStreamDefaultReader: nonEnumerable(import_web.ReadableStreamDefaultReader),
    TextDecoder: nonEnumerable(import_util.TextDecoder),
    TextEncoder: nonEnumerable(import_util.TextEncoder),
    TextDecoderStream: nonEnumerable(import_web.TextDecoderStream),
    TextEncoderStream: nonEnumerable(import_web.TextEncoderStream),
    TransformStream: nonEnumerable(import_web.TransformStream),
    URL: nonEnumerable(URL),
    // Note: This API isn't available in the TypeScript DOM bindings yet
    // https://github.com/microsoft/TypeScript-DOM-lib-generator/issues/1199
    URLPattern: nonEnumerable(import_urlpattern_polyfill.URLPattern),
    URLSearchParams: nonEnumerable(URLSearchParams),
    WritableStream: nonEnumerable(import_web.WritableStream),
    WritableStreamDefaultWriter: nonEnumerable(import_web.WritableStreamDefaultWriter),
    WritableStreamDefaultController: nonEnumerable(
      import_web.WritableStreamDefaultController
    ),
    ReadableByteStreamController: nonEnumerable(import_web.ReadableByteStreamController),
    ReadableStreamBYOBReader: nonEnumerable(import_web.ReadableStreamBYOBReader),
    ReadableStreamBYOBRequest: nonEnumerable(import_web.ReadableStreamBYOBRequest),
    ReadableStreamDefaultController: nonEnumerable(
      import_web.ReadableStreamDefaultController
    ),
    TransformStreamDefaultController: nonEnumerable(
      import_web.TransformStreamDefaultController
    ),
    Request: nonEnumerable(import_undici2.Request),
    Response: nonEnumerable(import_undici2.Response),
    atob: writable(atob_default),
    btoa: writable(btoa_default),
    setInterval: writable(setInterval),
    setTimeout: writable(setTimeout),
    clearInterval: writable(clearInterval),
    clearTimeout: writable(clearTimeout),
    console: nonEnumerable(
      new Proxy(console, {
        get(target, prop) {
          switch (prop) {
            case "log":
            case "info":
            case "debug":
              return (...args) => console[prop].call(
                console,
                (0, import_chalk.magenta)(`[${prop.toUpperCase()}]`),
                (0, import_chalk.yellow)(urlPathname),
                ...args
              );
            case "warn":
            case "error":
              return (...args) => console.log(
                (0, import_chalk.red)(`[${prop.toUpperCase()}]`),
                (0, import_chalk.yellow)(urlPathname),
                ...args
              );
            default:
              return target[prop];
          }
        }
      })
    ),
    crypto: writable(import_crypto.webcrypto),
    Crypto: nonEnumerable(import_crypto.webcrypto.constructor),
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    SubtleCrypto: nonEnumerable(import_crypto.webcrypto.subtle),
    fetch: writable(fetch_default(config)),
    performance: writable(import_perf_hooks.performance),
    queueMicrotask: nonEnumerable(queueMicrotask),
    // reportError is implemented below
    /* eslint-disable @typescript-eslint/no-explicit-any */
    structuredClone: nonEnumerable(
      globalThis.structuredClone ?? function(value) {
        return (0, import_v8.deserialize)((0, import_v8.serialize)(value));
      }
    ),
    /* eslint-enable */
    Navigator: nonEnumerable(Navigator),
    navigator: {
      get() {
        return navigator;
      },
      configurable: true,
      enumerable: true
    },
    Window: {
      value: Window,
      configurable: true,
      enumerable: false,
      writable: true
    }
  });
  const window = Object.setPrototypeOf(
    Object.defineProperties(globalProperties, {
      window: readOnly(globalProperties),
      self: readOnly(globalProperties)
    }),
    Window.prototype
  );
  window.reportError = (error) => {
    const ev = new ErrorEvent("error", {
      colno: 0,
      error,
      filename: "",
      lineno: 0,
      message: (error == null ? void 0 : error.message) ?? "",
      cancelable: true
    });
    if (window.dispatchEvent(ev)) {
      queueMicrotask(() => {
        throw error;
      });
    }
  };
  const reportUnhandledRejection = (reason, promise) => {
    const ev = new PromiseRejectionEvent("unhandledrejection", {
      reason,
      promise,
      cancelable: true
    });
    return window.dispatchEvent(ev);
  };
  return {
    vmContext: vm.createContext(window),
    reportUnhandledRejection
  };
}
function writable(value) {
  return {
    value,
    configurable: true,
    enumerable: true,
    writable: true
  };
}
function nonEnumerable(value) {
  return {
    value,
    configurable: true,
    enumerable: false,
    writable: true
  };
}
function readOnly(value) {
  return {
    value,
    configurable: true,
    enumerable: true,
    writable: false
  };
}

// src/run.ts
async function run(task) {
  if (!Object.prototype.hasOwnProperty.call(vm2, "SourceTextModule")) {
    throw new Error(
      "Modules support requires the --experimental-vm-modules flag"
    );
  }
  const { vmContext, reportUnhandledRejection } = createContext2(
    task.cwd,
    task.urlPathname,
    task.config
  );
  const context = vm2.createContext(vmContext);
  let unhandledPromise = void 0;
  const onUnhandledRejection = (reason, promise) => {
    if (reportUnhandledRejection(reason, promise)) {
      console.error(`Unhandled promise rejection: ${reason}`);
      unhandledPromise = promise;
    }
  };
  process.on("unhandledRejection", onUnhandledRejection);
  const module2 = new vm2.SourceTextModule(task.code.toString(), {
    identifier: (0, import_path.join)(task.cwd, task.scriptName),
    context
  });
  await module2.link(async () => void 0);
  await module2.evaluate();
  let result;
  const namespace = module2.namespace;
  if (Object.prototype.hasOwnProperty.call(namespace, "default")) {
    if (typeof namespace.default === "function" || (0, import_types.isAsyncFunction)(namespace.default)) {
      result = await namespace.default(task.payload);
    } else {
      result = namespace.default;
    }
  }
  process.off("unhandledRejection", onUnhandledRejection);
  if (unhandledPromise) {
    return Promise.reject(new Error("An unhandled promise rejection occurred"));
  }
  return result;
}

// src/apply-source-maps.ts
var import_source_map = require("source-map");
var import_path2 = require("path");
var STACK_TRACE_LINE_REGEX = /at (?<async>async )?(?<functionName>.+) \((?<filePath>.+\/)?(?<fileName>.+):(?<line>\d+):(?<column>\d+)\)/m;
async function applySourcemapsToStackTrace(scriptName, sourceMap, stackTrace) {
  const sourceMapConsumers = {};
  try {
    const modifiedLines = await Promise.all(
      stackTrace.split("\n").map(
        (line) => applySourcemapsToStackTraceLine(
          line,
          scriptName,
          sourceMap,
          sourceMapConsumers
        )
      )
    );
    return modifiedLines.join("\n");
  } catch (e) {
    return stackTrace;
  } finally {
    try {
      for (const consumer of Object.values(sourceMapConsumers)) {
        consumer.destroy();
      }
    } catch (e) {
    }
  }
}
async function applySourcemapsToStackTraceLine(stackTraceLine, scriptName, sourceMap, sourceMapConsumers) {
  const match = STACK_TRACE_LINE_REGEX.exec(stackTraceLine);
  if (!match || !match.groups) {
    return stackTraceLine;
  }
  const { async, functionName, filePath, fileName, line, column } = match.groups;
  if (scriptName !== fileName) {
    return stackTraceLine;
  }
  if (!sourceMapConsumers[fileName]) {
    sourceMapConsumers[fileName] = await new import_source_map.SourceMapConsumer(
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      sourceMap.toString("utf-8")
    );
  }
  const {
    source: sourcePath,
    line: originalLine,
    column: originalColumn
  } = sourceMapConsumers[fileName].originalPositionFor({
    line: Number(line),
    column: Number(column)
  });
  if (sourcePath && originalLine !== void 0 && originalColumn !== void 0) {
    const absoluteSourcePath = (0, import_path2.join)(filePath, sourcePath);
    return `    at ${async ? "async " : ""}${functionName} (${absoluteSourcePath}:${originalLine}:${originalColumn})`;
  } else {
    return stackTraceLine;
  }
}

// src/server.ts
var maxConnections = parseInt(process.env.DT_APP_SERVERLESS_MAX_CONNECTIONS);
var server = (0, import_net.createServer)();
server.maxConnections = isNaN(maxConnections) ? 128 : maxConnections;
server.on("connection", (socket) => {
  const chunks = [];
  let bytesLength = 0;
  async function dataListener(chunk) {
    if (bytesLength === 0) {
      bytesLength = await new Promise((resolve) => {
        const rl = readline.createInterface({
          input: new import_stream.PassThrough().end(chunk)
        });
        rl.once("line", (line) => {
          const dataByteLength = parseInt(line);
          const selfByteLength = Buffer.from(
            dataByteLength.toString()
          ).byteLength;
          chunks.push(chunk.slice(selfByteLength));
          resolve(selfByteLength + dataByteLength);
        });
      });
    } else {
      chunks.push(chunk);
    }
    if (socket.bytesRead === bytesLength) {
      socket.emit("end");
    }
  }
  socket.on("data", dataListener);
  socket.once("end", async () => {
    socket.removeListener("data", dataListener);
    let scriptName;
    let sourceMap;
    const rpcResult = {};
    try {
      const rpcRequest = (0, import_v82.deserialize)(Buffer.concat(chunks));
      scriptName = rpcRequest.scriptName;
      sourceMap = rpcRequest.sourceMap;
      rpcResult.result = await run(rpcRequest);
    } catch (error) {
      if (scriptName && sourceMap && error.stack) {
        error.stack = await applySourcemapsToStackTrace(
          scriptName,
          sourceMap,
          error.stack
        );
      }
      rpcResult.error = (0, import_v82.serialize)(error);
    } finally {
      socket.write((0, import_v82.serialize)(rpcResult), (error) => {
        if (error) {
          console.error(error);
        }
        socket.end();
      });
    }
  });
  socket.on("drain", () => {
    socket.resume();
  });
  socket.on("error", (error) => {
    console.error(error);
  });
  socket.once("close", (error) => {
    if (error) {
      console.error(error);
    }
  });
});
process.once("exit", () => {
  server.close();
});
process.on("uncaughtException", (error) => {
  console.error("Uncaught exception:", error);
});
(0, import_devkit.runOnUnusedPort)((port) => {
  return new Promise((resolve, reject) => {
    const errListener = (error) => {
      reject(error);
    };
    server.once("error", errListener);
    server.once("listening", () => {
      server.removeListener("error", errListener);
      server.on("error", (error) => {
        console.error(error);
      });
      resolve();
    });
    server.listen(port, "localhost");
  });
}, 3e4).catch((error) => {
  console.error(error);
}).then(() => {
  const address = server.address();
  console.log("Listening on port " + address.port);
});
/**
 * @license
 * Copyright 2022 Dynatrace LLC
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//# sourceMappingURL=server.js.map
